package xyz.danielcortes.controllers.categoria;

import javax.swing.JOptionPane;
import xyz.danielcortes.models.Categoria;
import xyz.danielcortes.repository.CategoriaRepository;
import xyz.danielcortes.views.categoria.CategoriaCreatePanel;

public class CategoriaCreateController {
  private CategoriaRepository categoriaRepository;
  private CategoriaCreatePanel view;

  public CategoriaCreateController(CategoriaCreatePanel view) {
    this.view = view;
    categoriaRepository = new CategoriaRepository();
    this.setupListeners();
  }

  private void setupListeners() {
    view.getNombreField().addActionListener(e -> save());
    view.getGuardarButton().addActionListener(e -> save());
  }

  private void save() {
    String nombre = view.getNombreField().getText();
    if(!validateNombre(nombre)) return;

    Categoria categoria = new Categoria();
    categoria.setNombre(nombre);

    categoriaRepository.save(categoria);

    this.view.getNombreField().setText("");
    this.view.getNombreField().requestFocus();
  }

  private boolean validateNombre(String nombre) {
    if (nombre == null) {
      JOptionPane.showMessageDialog(
          this.view.getContentPane(),
          "El nombre es nulo",
          "Error",
          JOptionPane.ERROR_MESSAGE);
      return false;
    } else if (nombre.isEmpty()) {
      JOptionPane.showMessageDialog(
          this.view.getContentPane(),
          "El nombre esta vacío",
          "Error",
          JOptionPane.ERROR_MESSAGE);
      return false;
    }
    return true;
  }

  public CategoriaCreatePanel getView() {
    return view;
  }

}
